<?php
defined('PHP168_PATH') or die();

/**
* 更新模型内容入口文件
**/

$this_system->init_model();
$this_model or message('no_such_cms_model');
$this_model['enabled'] or message('sites_model_disabled');

if(REQUEST_METHOD == 'GET'){
	$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
	$id or message('no_such_item');

	if(isset($_GET['verified'])){
		$verified = $_GET['verified'] == 1 ? true : false;
	}else{
		$verified = true;
	}
	if($verified){
		
		$select = select();
		$select->from($this_module->main_table .' AS m', 'm.*');
		$select->inner_join($this_module->addon_table .' AS a', 'a.*', 'm.id = a.iid');
		$select->inner_join($this_module->table .' AS i', 'i.*', 'i.id = m.id');
		$select->in('i.id', $id);
		$select->in('a.page', 1);
		$data = $core->select($select, array('single' => true));
		$data or message('no_such_item');
		
	}else{
		
		$select = select();
		$select->from($this_module->unverified_table, 'data');
		$select->in('id', $id);
		$_data = $core->select($select, array('single' => true));
		$_data or message('no_such_item');
		
		$_data = mb_unserialize($_data['data']);
		$data = array_merge($_data['addon'], $_data['item'], $_data['main']);
		
	}
	//检查分类权限
	if($data['uid'] != $UID){
		$this_system->check_manager('update') or message($P8LANG['sites_item']['no_category_privilege']);
	}
	$allow_verify = $this_controller->check_action('verify');
	if($this_module->CONFIG['allow_verify'] && !$verified && !$allow_verify){
		message($P8LANG['sites_item']['no_category_update_privilege']);
	}
	$this_module->format_data($data);

	//内容属性
	$data['attributes'] = array_flip(explode(',', $data['attributes']));
	$data['summary'] = html_entity_decode($data['summary']);
	$data['level_date'] = $data['level_time'] > 0 ? date('Y-m-d H:i:s', $data['level_time']) : '';
	$allow_create_time = $this_controller->check_action('create_time');
	$allow_attribute = $this_controller->check_action('attribute');
	$allow_set_views = $this_controller->check_action('setviews');
	//config
	$config = mb_unserialize(stripslashes($data['config']));
	$config['allow_ip']['enabled'] = isset($config['allow_ip']['enabled']) ? $config['allow_ip']['enabled'] : 0;
	$config['allow_ip']['collectip'] = isset($config['allow_ip']['collectip']) ? $config['allow_ip']['collectip'] : array();
	$config['allow_ip']['beginip'] = isset($config['allow_ip']['beginip']) ? trim($config['allow_ip']['beginip']) : '';
	$config['allow_ip']['endip'] = isset($config['allow_ip']['endip']) ? trim($config['allow_ip']['endip']) : '';
	$config['allow_ip']['ruleoutip'] = isset($config['allow_ip']['ruleoutip']) ? $config['allow_ip']['ruleoutip'] : array();
	//预留字段
	$custom = array('custom_a','custom_b','custom_c','custom_d','custom_e','custom_f','custom_g','custom_h','custom_i','custom_j');
	
	//权重
	$allow_level = $this_controller->check_action('level');
	//浏览权限
	$authority_enable = $this_module->CONFIG['authority'];
	$authority = $authority_viewer = array();
    if($authority_enable) {
		$core->get_cache('role');
		//用户组
		$authority = $data['authority'] ? explode(",",$data['authority']) : array();
		//用户
		if(!empty($config['authority_viewer'])){
			$authority_viewers = implode(',',$config['authority_viewer']);
			$member = &$core->load_module('member');
			$authority_viewer = $core->DB_master->fetch_all("SELECT id,username FROM {$member->table} WHERE id IN ($authority_viewers)");
		}
	} 
	$select = select();
	$select->from($this_module->attribute_table. ' AS a', 'a.aid, a.timestamp, a.last_setter');
	$select->in('a.id', $id);
	$_attributes = $core->list_item(
		$select,
		array(
			'page' => 0
		)
	);
	$attributes = array();
	foreach($_attributes as $v){
		$attributes[$v['aid']] = $v;
	}
	unset($_attributes);
	$my_addible_category = p8_json($this_controller->get_acl('my_addible_category'));
	$uploader_config = $core->get_config('core','uploader');
	$thumb_width = $uploader_config['thumb']['width'] ? intval($uploader_config['thumb']['width']) : 0;
	$thumb_height = $uploader_config['thumb']['height'] ? intval($uploader_config['thumb']['height']) : 0;
	require $this_model['path'] .'/member/update.php';
	
	$template = empty($this_model['CONFIG']['member_edit_template']) ? 'edit' : $this_model['CONFIG']['member_edit_template'];
	$item_config = $core->get_config('sites', 'item');
	$this_fields = $this_model['fields'];
	$core_config = $core->get_config('core', '');
	$allow_filter_word = $core_config['filter_word_enable'] ? true : false;
	$allow_content_censor = $core_config['content_censor_enabled'] ? true : false;
	include template($this_module, $template);
	
}else if(REQUEST_METHOD == 'POST'){
	
	//如果魔法引号开启strip掉
	$_POST = p8_stripslashes2($_POST);
	
	$id = isset($_POST['id']) ? intval($_POST['id']) : 0;
	$id or message('no_such_item');
	
	//大分类不允许发布信息
	$category_module = $this_system->load_module('category');	
	$category_module->get_cache();
	if($category_module->categories[$_POST['cid']]['type'] == 1) message('category_post_rule');
	
	if(!$this_controller->check_admin_action('verify')){
		unset($_POST['verify']);
	}
	
	if(isset($_POST['verified'])){
		$verified = $_POST['verified'] == 1 ? true : false;
	}else{
		$verified = true;
	}
	
	$_POST['verify'] = $this_controller->check_category_action('autoverify', $_POST['cid'])? 1 : 0;	
	$data = $this_module->data('read', $id);
	if(empty($data)){
		$data = $this_module->data_unverified($id);
		$_POST['verify'] = $data['uid'] != $UID ? 0 : $_POST['verify'];
	}
	//浏览量
	$_POST['views'] = $this_controller->check_category_action('setviews', $_POST['cid']) ? intval($_POST['views']) : $data['views'];	
	require $this_model['path'] .'member/update.php';
	
	$this_controller->update($id, $_POST, $verified) or message('fail');
	/*
	* 针对子站推送数据给总站时，当子站修改数据时，能同步修改总站相应数据
	*/
	$cms_item_config = $core->get_config('cms','item');
	if($cms_item_config['sites_to_cms_connect']){
		$stop_table = $core->TABLE_.'sites_stop_data';
		$new_data = $DB_master->fetch_one("select `new_id` from $stop_table where `item_id` = $id");
		if(!empty($new_data)){
			$new_id = $new_data['new_id'];		
			$cms = $core->load_system('cms');
			$cms->init_model();
			$item = $cms->load_module('item');
			$verified_data = true;
			$read_data = $item->data('read', $new_id);
			if(empty($read_data)) {
				$read_data = $item->data_unverified($new_id);
				$verified_data = false;
			}		
			if(!empty($read_data)){
				$_POST['cid'] = $read_data['cid'];
				$controller = $core->controller($item);	
				$item->set_model($read_data['model']);
				$datas = $_POST;
				$datas['verify'] = 0;
				$datas['uid'] = $read_data['uid'];
				$datas['model'] = $read_data['model'];
				$UID = empty($UID) ? $read_data['uid'] : $UID;
				require $this_model['path'] .'/admin/update.php';
				$controller->update($new_id, $datas, $verified_data,true);
			}
		}
	}
	if(!$_POST['verify']){
		message($P8LANG['sites_item']['verify']['wait_again'], $this_module->U_controller .'-add?cid='.$_POST['cid'].'&model='.$_POST['model']);
	}else{
		$data['#category'] = $this_system->fetch_category($data['cid'],true);
		$static_view_url = $this_system->site_p8_url($this_module, $data, 'view');
		$verified = $_POST['verify'] ? 1 : 0;
		message(
			array(
				array('sites_to_edit', $this_module->U_controller .'-update?id='.$id.'&model='.$_POST['model'].'&verified='.$verified),
				array('sites_to_list', $this_module->U_controller .'-my_list?cid='.$_POST['cid'].'&model='.$_POST['model']),
				array('sites_to_view', $static_view_url.'?verify='. $_POST['verify'], '_blank'),
				array('sites_to_view_dynamic', $core->STATIC_URL.'/s.php/'.$this_system->SITE.'/item-view-id-'.$id .'?verify='. $_POST['verify'], '_blank'),
				array('sites_to_add', $this_module->U_controller .'-add?cid='.$_POST['cid'].'&model='.$_POST['model'])
			),
			$this_module->U_controller .'-add?cid='. $_POST['cid'] .'&model='. $_POST['model'],
			10000
		);
	}
	
}
